function TOOLPATH_GENERATION(profile,coeffs,E,G,rho,x_section,nu,d0,width,bar_length,number_of_elements,tol,number_fn,ploton,d)
%Here determine where the points start to change to find the undercut area
yaya=0;
for c=1:(number_of_elements-1)
if (d(c) ~= d(c+1))
yaya=yaya+1;
where(yaya)=c;
end;
end;
fixed_position=where(1);%??????????????????????????????????????????????????
last_fixed_position=(number_of_elements-fixed_position)+1;%????????????????
%Now I will get the new shape
New_d=[];
for k=1:fixed_position-1%??????????????????????????????????????????????????
New_d(k)=d(k);
end;
for k=(last_fixed_position+1):number_of_elements%??????????????????????????
New_d(k)=d(k);
end;
lala=0;
%The following gives the undercut points, and then saved into "New_ddd"
%for k=(fixed_position):(last_fixed_position)%??????????????????????????????
% lala=lala+1;
% New_ddd(lala)=d(k);
%end;
lalala=0;
cut_perc=1
lala=0;
lalala=lalala+1;
%length_all_the_time=((fixed_position)*(bar_length/600):(bar_length/600):(last_fixed_position)*(bar_length/600));
%Here moved "d" curve upper by "1/10"
for k=(fixed_position):(last_fixed_position)
lala=lala+1;
New_ddd(lala)=((d0-d(k))*(1-cut_perc))+d(k)+0.000025;
end;
lala=0;
for k=(fixed_position):(last_fixed_position)
lala=lala+1;
New_d(k)=New_ddd(lala);
end;
%-------------------------------------------------------------------------------------------------------------
%the number of points should be changed after the cutting beam length is
%decided, "points" is the number of points for undercut area
points=length(New_ddd);
line_number=3;
line=1:line_number
for i=1:points
%Here the value for X acis CC points should be updated after
%getting the CNC machine working.(The coordinates should be different)
CC_X(i,line)=((fixed_position+i-1).*bar_length./number_of_elements);
CC_Y(i,line)=(width/(line_number-1)).*(line-1);
CC_Z(i,line)=New_ddd(i);
end;
end;
figure(3)
mesh(CC_X,CC_Y,CC_Z);
%-------------------------------------------------------------------------------------------------------------
%CC to CL for side step
[surf_x_normal,surf_y_normal,surf_z_normal]=surfnorm(CC_X,CC_Y,CC_Z);
%toolpath CL points %still need interpolation
R=0.005;%??????????????????????????????????????????????????????????????????
PCL_X=CC_X-(R.*surf_x_normal);
PCL_Y=CC_Y-(R.*surf_y_normal);
PCL_Z=CC_Z-(R.*surf_z_normal);
%now input length_per_motor_step, this is the property of stepper
%motor, and should be checked latter, it shows the minimum length the
%stepper motor is capable of moving
length_per_motor_step=0.000002532;
%length_per_motor_step=0.0000015875;%???????????????????????????????????????
% if the stepper motor only moves at its minimum length, it
%requires too much of movements, then set each move to be 100 stepper
%motor minimum length. Here the program should keep trying different values
%so that it can ensure the accuracy is good AND does not take too much time
s=400*length_per_motor_step;%??????????????????????????????????????????????
%The following shows how many cuts aer required for the undercut area based
%on the motor increments set above
segment_double=(length(PCL_X(:,1)).*(bar_length./number_of_elements))/s;
% make the obtained segment number into integer
NN=0;
for nn=1:(number_of_elements*10)
if nn>segment_double
NN=NN+1;
segment_int(NN)=nn;
end;
end;
HOW_MANY_SEGMENT=segment_int(1);
%-------------------------------------------------------------------------------------------------------------
%Once the segment number is changed to integer, the value is slightly
%larger than the original "double" value, thus, the motor increment is no
%longer "s", it is slightly smaller
tt_single_length=(PCL_X(length(PCL_X(:,1)),1)-PCL_X(1,1))/HOW_MANY_SEGMENT;
iii=0;
for x_direct=PCL_X(1,1):tt_single_length:PCL_X(length(PCL_X(:,1)),1)
iii=iii+1;
x_direction(iii,1)=x_direct;
Z_direction(iii,1)=interp1(PCL_X(:,1),PCL_Z(:,1),x_direct);
end;
%-------------------------------------------------------------------------------------------------------------
%forward Step
column_number=length(x_direction(iii,1));
%Now I will form all CL points into three matrices
row_number=length(x_direction(:,1));
%-------------------------------------------------------------------------------------------------------------
CL_X=zeros(row_number,column_number);
CL_Y=zeros(row_number,column_number);
CL_Z=zeros(row_number,column_number);
%Here x and z axes CL points are saved into relative array
for column=1:column_number
for row=1:row_number
CL_X(row,column)=x_direction(row,1);
CL_Z(row,column)=Z_direction(row,1);
end;
end;
%-------------------------------------------------------------------------------------------------------------
side_cut=0;
side_cut_number=row_number;
sideside=side_cut_number/2;
shuangshu=false;
for nn=1:100
if nn==sideside
shuangshu=true;
end;
end;
if shuangshu %Can be divided by "2"
for side_CO=1:2:side_cut_number-1
side_cut_X(1,side_CO)=CL_X(side_CO,1);
side_cut_Y(1,side_CO)=0;
side_cut_Z(1,side_CO)=CL_Z(side_CO,1);
side_cut_X(2,side_CO)=CL_X(side_CO,1);
side_cut_Y(2,side_CO)=width;
side_cut_Z(2,side_CO)=CL_Z(side_CO,1);
end;
for side_CO=2:2:side_cut_number
side_cut_X(1,side_CO)=CL_X(side_CO,1);
side_cut_Y(1,side_CO)=width;
side_cut_Z(1,side_CO)=CL_Z(side_CO,1);
side_cut_X(2,side_CO)=CL_X(side_CO,1);
side_cut_Y(2,side_CO)=0;
side_cut_Z(2,side_CO)=CL_Z(side_CO,1);
end;
else %Cant be divided by "2"
for side_CO=1:2:side_cut_number
side_cut_X(1,side_CO)=CL_X(side_CO,1);
side_cut_Y(1,side_CO)=0;
side_cut_Z(1,side_CO)=CL_Z(side_CO,1);
side_cut_X(2,side_CO)=CL_X(side_CO,1);
side_cut_Y(2,side_CO)=width;
side_cut_Z(2,side_CO)=CL_Z(side_CO,1);
end;
for side_CO=2:2:side_cut_number-1
side_cut_X(1,side_CO)=CL_X(side_CO,1);
side_cut_Y(1,side_CO)=width;
side_cut_Z(1,side_CO)=CL_Z(side_CO,1);
side_cut_X(2,side_CO)=CL_X(side_CO,1);
side_cut_Y(2,side_CO)=0;
side_cut_Z(2,side_CO)=CL_Z(side_CO,1);
end;
end;
%-------------------------------------------------------------------------------------------------------------
forward_cut_number=length(side_cut_X(1,:));%?????????????????????????????
forward=forward_cut_number/2; forward_shuangshu=false;
for nnn=1:100
if nnn==forward
forward_shuangshu=true;
end;
end;
SIDE_CUT_NUM=length(side_cut_X(1,:));
FORWARD_CUT_NUM=length(side_cut_Z(1,:));
TOTAL_CUT_NUM=0; TOTAL_SIDE=0;
for FORWARD_STEP=1:SIDE_CUT_NUM
TOTAL_CUT_NUM=TOTAL_CUT_NUM+1;
TOOL_CUT_X_TEMP(TOTAL_CUT_NUM)=side_cut_X(1,FORWARD_STEP);
TOOL_CUT_Y_TEMP(TOTAL_CUT_NUM)=side_cut_Y(1,FORWARD_STEP);
TOOL_CUT_Z_TEMP(TOTAL_CUT_NUM)=side_cut_Z(1,FORWARD_STEP);
TOTAL_CUT_NUM=TOTAL_CUT_NUM+1;
TOOL_CUT_X_TEMP(TOTAL_CUT_NUM)=side_cut_X(2,FORWARD_STEP);
TOOL_CUT_Y_TEMP(TOTAL_CUT_NUM)=side_cut_Y(2,FORWARD_STEP);
TOOL_CUT_Z_TEMP(TOTAL_CUT_NUM)=side_cut_Z(2,FORWARD_STEP);
end;
for FORWARD_STEP=1:TOTAL_CUT_NUM+1
if FORWARD_STEP==TOTAL_CUT_NUM+1
TOOL_CUT_X(FORWARD_STEP)=TOOL_CUT_X_TEMP(1);
TOOL_CUT_Y(FORWARD_STEP)=TOOL_CUT_Y_TEMP(1);
TOOL_CUT_Z(FORWARD_STEP)=TOOL_CUT_Z_TEMP(1);
else
TOOL_CUT_X(FORWARD_STEP)=TOOL_CUT_X_TEMP(FORWARD_STEP);
TOOL_CUT_Y(FORWARD_STEP)=TOOL_CUT_Y_TEMP(FORWARD_STEP);
TOOL_CUT_Z(FORWARD_STEP)=TOOL_CUT_Z_TEMP(FORWARD_STEP);
end;
end;
figure(5)
plot3(TOOL_CUT_X,TOOL_CUT_Y,TOOL_CUT_Z)
%-------------------------------------------------------------------------------------------------------------
%Coordinates_to_steps(TOOL_CUT_X,TOOL_CUT_Y,TOOL_CUT_Z,TOTAL_CUT_NUM,length_per_motor_step)
%-------------------------------------------------------------------------------------------------------------
%G_Code_Generation(TOOL_CUT_X,TOOL_CUT_Y,TOOL_CUT_Z,TOTAL_CUT_NUM)
%-------------------------------------------------------------------------------------------------------------
